@if (@a==@b) @end /*

@echo off
rem Color 0F
Color 1F
setlocal EnableDelayedExpansion

rem mode con:cols=80 lines=40

cls





::================================================================================
:: Create main folder if needed and other variables.
::================================================================================

:createDir

:: Path to this script (with \ at the end).
:: This is an absolute path.
set "_root_path=%~dp0"

:: Default name for the folder with all settings will be "settings" (without \ at the end).
:: This is a relative path (relative to _root_path).
set "_settings_path=settings"
if not exist "%_root_path%%_settings_path%" md "%_root_path%%_settings_path%"

:: Var will be store the name of selected settings.
set "_setting_name="

:: Txt file with default settings.
set "_default_txt=default.txt"

:: Temporary folder.
rem set "_tmp_name=temp"
rem if not exist "%_root_path%%_tmp_name%" md "%_root_path%%_tmp_name%"
rem set "_tmp=%_root_path%%_tmp_name%"





::================================================================================
:: Display welcome dialog and ask user for his choise.
::================================================================================

:start
call :showTitle

:mainMenu
echo What would you like to do?
echo Press corresponding key on your keyboard and accept by pressing [Enter].
echo.
echo -----------------------------
echo           MAIN MENU
echo -----------------------------
echo  [1] Export settings
echo  [2] Import settings
echo  [3] Set default settings
echo  [4] Reset iStripper
echo  [O] Browse settings folder
echo  [H] Help
echo  [A] About
echo  [Q] Quit
echo -----------------------------
echo.

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :start
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	goto :export
)
if /i %_choice% == 2 (
	set flag=1
	goto :import
)
if /i %_choice% == 3 (
	set flag=1
	goto :default
)
if /i %_choice% == 4 (
	set flag=1
	goto :reset
)
if /i %_choice% == o (
	set flag=1
	explorer "!_settings_path!"
	goto :start
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if /i %_choice% == a (
	set flag=1
	goto :about
)
if %flag% EQU 0 (
	goto :start
)










::################################################################################
:: Help.
::################################################################################

:about
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      About this program
echo.
echo -------------------------------------------------------------------------------
echo.
echo Settings Manager for iStripper
echo.
echo version: 1.2 (2018-12-09)
echo author: LukaszR
echo webpage: www.isworkshop.eu
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :start

:help
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo This tool will help you export/import all iStripper settings.
echo All options from the "Settings" tab, filter settings from "My Collection"
echo and "Girls Store" tabs, views, the settings of skins, scenes and music
echo files can be saved and you will be able to restore them in the future.
echo.
echo Press 1 if you want to export settings.
echo Press 2 if you want to import previously saved settings.
echo Press 3 if you want to save your settings as default.
echo Press 4 if you want to reset iStripper to its default settings.
echo Press O to browse the folder with saved settings.
echo Press H to display tips (this text).
echo Press Q to exit the program.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :start

:helpExport
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo You can choose if you want to export only settings from the "Settings" tab
echo or all settings, including those from "My collection", "Girls Store", "Music"
echo and "Full screen" tab.
echo.
echo Press 1 to export only settings from the "Settings" tab.
echo Press 2 to export everything, including:
echo - settings from the "Settings" tab,
echo - "My Collection" filters, views and sort options,
echo - "Girls Store" filters, views and sort options,
echo - scene options from the "Full screen" tab (scenes),
echo - music options from the "Music" tab (with track list).
echo Press H to display tips (this text).
echo Press B to go back to main menu.
echo Press Q to exit the program.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :export

:helpImport
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo You can choose a folder containing the settings to import.
echo.
echo Press 1 to select settings to import.
echo Press O to browse the folder with saved settings.
echo Press H to display tips (this text).
echo Press B to go back to main menu.
echo Press Q to exit the program.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :import

:helpImportRange
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo You can choose if you want to import only settings in the "Settings" tab
echo or all settings, including those in "My collection", "Girls Store", "Music"
echo and "Full screen" tab.
echo.
echo Press 1 to import only settings in the "Settings" tab.
echo Press 2 to import everything, including:
echo - settings in the "Settings" tab,
echo - "My Collection" filters, views and sort options,
echo - "Girls Store" filters, views and sort options,
echo - scene options in the "Full screen" tab (scenes),
echo - music options in the "Music" tab (with track list).
echo Press D to display description of selected set of settings.
echo Press H to display tips (this text).
echo Press B to go back to previous menu.
echo Press Q to exit the program.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :importSelectRange

:helpDefault
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo You can set your own default settings and create a shortcut on your desktop.
echo Each time you use this shortcut, the default settings will be imported.
echo.
echo Press 1 to choose the settings you want to use as default.
echo Press O to browse the folder with saved settings.
echo Press H to display tips (this text).
echo Press B to go back to main menu.
echo Press Q to exit the program.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :default

:helpDefaultRange
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo You can choose if you want to include only settings in the "Settings" tab
echo or all settings, including those in "My collection", "Girls Store", "Music"
echo and "Full screen" tab.
echo.
echo Press 1 to include only settings in the "Settings" tab.
echo Press 2 to include everything, including:
echo - settings in the "Settings" tab,
echo - "My Collection" filters, views and sort options,
echo - "Girls Store" filters, views and sort options,
echo - scene options in the "Full screen" tab (scenes),
echo - music options in the "Music" tab (with track list).
echo Press D to display description of selected set of settings.
echo Press H to display tips (this text).
echo Press B to go back to previous menu.
echo Press Q to exit the program.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :defaultSelectRange





::################################################################################
:: Export settings
::################################################################################
:: 1 - Select range: Basic, Everything (other opt: Help, Back, Quit).
:: 2 - Enter name (other opt: Help, Back, Quit).
:: 3 - Accept/Confirm (other opt: Back, Quit).
:: 4 - Add description.
:: 5 - Set as default: Yes, No.

:export
call :showTitle export
set "steps=5"

echo  STEP 1/%steps%: SELECT RANGE
echo -------------------------
echo.
echo So you want to export your settings, huh? What would you like to export?
echo.
echo ----------------------------
echo  [1] Export basic settings
echo  [2] Export everything
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ----------------------------
echo.

:: Action.
set "_method=1"
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :export
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	set "_method=1"
	goto :exportProvideName
)
if /i %_choice% == 2 (
	set flag=1
	set "_method=2"
	goto :exportProvideName
)
if /i %_choice% == h (
	set flag=1
	goto :helpExport
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :export
)





::================================================================================
:: Provide the name for the new set of settings.
::================================================================================

:exportProvideName
call :showTitle export

echo  STEP 2/%steps%: ENTER NAME
echo -----------------------
echo.
if %_method% EQU 1 echo Program will export only settings from "Settings" tab.
if %_method% EQU 2 echo Program will export all settings.
echo.
echo Enter a name for current settings. You can use letters, digits
echo and special characters:   (space); _ (underscore); - (dash); . (dot);
echo Try to avoid other special characters because they may break the script.
echo For complete list of special characters, refer to readme file.
echo.

set /p "_setting_name=Enter new name: "
call :trim _setting_name %_setting_name%

:: Check if the new name is empty string.
if not defined _setting_name goto :exportProvideName





::================================================================================
:: Create subfolder for the new set of settings.
::================================================================================

:createNewSettings
call :showTitle export

echo  STEP 3/%steps%: CONFIRM
echo --------------------
echo.
set "message="
if %_method% EQU 1 set "message=basic"
if %_method% EQU 2 set "message=all"
echo Program will export %message% settings under this name: "%_setting_name%"
echo.
echo -----------------
echo  [1] Export now
echo  [B] Back
echo  [Q] Quit
echo -----------------
echo.

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :createNewSettings
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	goto :createNewSettings_action
)
if /i %_choice% == b (
	set flag=1
	goto :export
)
if %flag% EQU 0 (
	goto :createNewSettings
)

:createNewSettings_action

if not exist "%_settings_path%\%_setting_name%" (
	rem Create new directory and save settings.
	md "!_settings_path!\!_setting_name!"
) else (
	rem Show title
	call :showTitle export
	echo  STEP 3/!steps!: CONFIRM
	echo --------------------
	echo.
	rem Directory already exists. Overwrite?
	echo Settings with the name "!_setting_name!" already exist.
	echo Do you want to overwrite?
	echo.
	echo ----------
	echo  [Y] Yes
	echo  [N] No
	echo ----------
	echo.
	rem Action
	set "_choice="
	set /p "_choice=Your choice: "
	if [!_choice!]==[] goto :createNewSettings_action
	if /i !_choice! == n (
		goto :exportProvideName
	) else (
		if /i !_choice! == y (
			del /q/f "!_settings_path!\!_setting_name!\*.reg" >nul 2>nul
			del /q/f "!_settings_path!\!_setting_name!\*.mpl" >nul 2>nul
			del /q/f "!_settings_path!\!_setting_name!\info.txt" >nul 2>nul
			goto :exportBasicSettings
		) else (
			goto :createNewSettings
		)
	)
)





::================================================================================
:: Read and save basic settings from the registry ("Settings" tab).
::================================================================================

:exportBasicSettings

echo.
echo Exporting. Please wait...

:: Relative path to the current set of settings.
set "_rel_path=%_settings_path%\%_setting_name%"
:: File to store the settings.
set _file="%_rel_path%\settings.reg"

:: Prepare file.
echo Windows Registry Editor Version 5.00> %_file%
echo.>> %_file%

:: List of keys and values.
set "myKey[0]=HKEY_CURRENT_USER\Control Panel\Desktop"
set "myKey[1]=HKEY_CURRENT_USER\Software\Totem\vghd"
set "myKey[2]=HKEY_CURRENT_USER\Software\Totem\vghd\DLM"
set "myKey[3]=HKEY_CURRENT_USER\Software\Totem\vghd\fullscreen"
set "myKey[4]=HKEY_CURRENT_USER\Software\Totem\vghd\live"
set "myKey[5]=HKEY_CURRENT_USER\Software\Totem\vghd\parameters"
set "myKey[6]=HKEY_CURRENT_USER\Software\Totem\vghd\player"
set "myKey[7]=HKEY_CURRENT_USER\Software\Totem\vghd\System"
set "myKey[8]=HKEY_CURRENT_USER\Software\Totem\vghd\System\tips"
set "myKey[9]=HKEY_CURRENT_USER\Software\Totem\vghd\systray"
set "myKey[10]=HKEY_CURRENT_USER\Software\Totem\vghd\ui"
set myValues[0]=ScreenSaveTimeOut
set myValues[1]=animsList defaultResolution ModelTitleDuration ModelTitleFrequency ModelTitleZoom oneClickPurchaseEnabled uploadLimit acceptedTermsVersion effectsVolume
set myValues[2]=explicit p2p
set myValues[3]=collection_1 collection_2 collection_3 collection_4 collection_5 ModelTitleFrequency NudityEnabled
set myValues[4]=Frequency
set myValues[5]=Animations autoPlayDemos eraseClipsWhenDeletingPreviews EroRandom DragDropClipsEnabled GirlOfDay HotKeyMod HotKeyVal MinimumSceneDuration MusicGoOn screenSaverAffinity ScrEroRandom ScrMusic ScrSound ShowDuration startAtBoot useBuyWindow UseScreenSaver WindowPlayerAnimations WindowPlayerBehaviour WPMusic WPSound SoundVolume MusicVolume ScrSoundVolume ScrMusicVolume
set myValues[6]=actionsInMenu collection_1 collection_2 collection_3 collection_4 collection_5 defaultAction duration expectedHeightPercent expectedLargeHeightPercent frequency maximumActors maximumLargeScaleEnabled
set myValues[7]=Langage MaskFullPreload nudityClipsDisabled PasswordProtected SilentDiscreet
set myValues[8]=enabled usePlatformNotifications
set myValues[9]=customType defaultAction
set myValues[10]=advancedSettingsEnabled currentSkin

:: Default values.
set "myDefaultVal[0][0]=dword:0000003c"
set "myDefaultVal[1][0]=dword:00000001"
set "myDefaultVal[1][1]=dword:00000002"
set "myDefaultVal[1][2]=dword:00000fa0"
set "myDefaultVal[1][3]=dword:00000003"
set myDefaultVal[1][4]="1"
set myDefaultVal[1][5]="false"
set "myDefaultVal[1][6]=dword:00007800"
set "myDefaultVal[1][7]=dword:00000000"
set "myDefaultVal[1][8]=dword:00000064"
set "myDefaultVal[2][0]=dword:00000001"
set "myDefaultVal[2][1]=dword:00000001"
set myDefaultVal[3][0]="true"
set myDefaultVal[3][1]="true"
set myDefaultVal[3][2]="true"
set myDefaultVal[3][3]="true"
set myDefaultVal[3][4]="true"
set "myDefaultVal[3][5]=dword:00000003"
set "myDefaultVal[3][6]=dword:00000001"
set "myDefaultVal[4][0]=dword:0000000a"
set "myDefaultVal[5][0]=dword:0000003e"
set myDefaultVal[5][1]="true"
set myDefaultVal[5][2]="false"
set "myDefaultVal[5][3]=dword:00000001"
set "myDefaultVal[5][4]=dword:00000001"
set myDefaultVal[5][5]="true"
set myDefaultVal[5][6]="ALT"
set myDefaultVal[5][7]="SPACE"
set "myDefaultVal[5][8]=dword:000927c0"
set "myDefaultVal[5][9]=dword:00000000"
set "myDefaultVal[5][10]=dword:00000000"
set "myDefaultVal[5][11]=dword:00000000"
set "myDefaultVal[5][12]=dword:00000001"
set "myDefaultVal[5][13]=dword:00000001"
set "myDefaultVal[5][14]=dword:00000007"
set "myDefaultVal[5][15]=dword:00000001"
set "myDefaultVal[5][16]=dword:00000001"
set "myDefaultVal[5][17]=dword:00000000"
set "myDefaultVal[5][18]=dword:0000003e"
set "myDefaultVal[5][19]=dword:00000000"
set "myDefaultVal[5][20]=dword:00000001"
set "myDefaultVal[5][21]=dword:00000001"
set "myDefaultVal[5][22]=dword:00000046"
set "myDefaultVal[5][23]=dword:00000046"
set "myDefaultVal[5][24]=dword:00000046"
set "myDefaultVal[5][25]=dword:00000046"
set "myDefaultVal[6][0]=hex(7):44,00,6f,00,4c,00,61,00,72,00,67,00,65,00,53,00,6d,00,61,00,6c,00,6c,00,00,00,44,00,6f,00,46,00,75,00,6c,00,6c,00,53,00,63,00,72,00,65,00,65,00,6e,00,00,00,44,00,6f,00,53,00,74,00,6f,00,72,00,65,00,00,00,44,00,6f,00,53,00,65,00,74,00,74,00,69,00,6e,00,67,00,73,00,00,00,44,00,6f,00,53,00,74,00,72,00,69,00,70,00,74,00,65,00,61,00,73,00,65,00,00,00,44,00,6f,00,54,00,6f,00,67,00,67,00,6c,00,65,00,57,00,69,00,73,00,68,00,65,00,64,00,00,00,00,00"
set myDefaultVal[6][1]="true"
set myDefaultVal[6][2]="true"
set myDefaultVal[6][3]="true"
set myDefaultVal[6][4]="true"
set myDefaultVal[6][5]="true"
set myDefaultVal[6][6]="enum:DoLargeSmall"
set "myDefaultVal[6][7]=dword:00000007"
set "myDefaultVal[6][8]=dword:0000001e"
set "myDefaultVal[6][9]=dword:00000064"
set "myDefaultVal[6][10]=dword:00000005"
set "myDefaultVal[6][11]=dword:00000001"
set "myDefaultVal[6][12]=dword:00000001"
set myDefaultVal[7][0]="en"
set myDefaultVal[7][1]="1"
set myDefaultVal[7][2]="false"
set myDefaultVal[7][3]="false"
set "myDefaultVal[7][4]=dword:00000000"
set myDefaultVal[8][0]="true"
set myDefaultVal[8][1]="false"
set "myDefaultVal[9][0]=dword:00000000"
set "myDefaultVal[9][1]=dword:00000000"
set myDefaultVal[10][0]="false"
set myDefaultVal[10][1]="basic"

:: Count the number of keys to process.
set /a "keys_length=-1"
for /f %%a in ('set myKey[') do set /a "keys_length+=1"

:: Loop
for /l %%i in (0,1,%keys_length%) do (
	echo [!myKey[%%i]!]>> !_file!
	set /a counter=0
	rem Save values
	for %%j in (!myValues[%%i]!) do (
		rem Read value and type from the registry.
		rem It should be one of these three types of value: REG_DWORD, REG_SZ, REG_MULTI_SZ.
		set "_type="
		set "_value="
		set "_errlvl="
		set "_prefix="
		set "_suffix="
		call :readRegValue "!myKey[%%i]!" %%j _type _value _errlvl
		rem Check type.
		if /i !_type!==REG_DWORD (
			set "_prefix=dword:"
			set "_suffix="
			rem Remove the '0x' at the begginig of each value of this type.
			call set "_value=%%_value:0x=%%"
		) else if /i !_type!==REG_SZ (
			set "_prefix=""
			set "_suffix=""
			rem Replace single backslash (\) with double backslash (\\).
			call set "_value=%%_value:\=\\%%"
		) else if /i !_type!==REG_MULTI_SZ (
			set "_prefix=hex(7):"
			set "_suffix="
			rem Check if value isn't empty.
			IF [!_value!] EQU [] (
				set _value=00,00
			) else (
				rem Convert text to hex. Store the string in str.tmp file.
				set /p "=!_value!" < nul > str.tmp
				rem Create null.tmp file with the same number of Ascii zero characters.
				for %%a in (str.tmp) do fsutil file createnew null.tmp %%~za > nul
				rem Compare both files with FC /B and get the differences.
				set "hex="
				for /f "skip=1 tokens=2" %%a in ('fc /b str.tmp null.tmp') do set "hex=!hex!%%a"
				rem .tmp files are no longer used.
				del str.tmp null.tmp
				rem Replace Ascii '\0' with nul.
				call set "_value=%%hex:5C30=00%%"
				rem Get length of the string.
				set "len=0"
				set "s=!_value!"
				for %%a in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
					if "!s:~%%a,1!" NEQ "" (
						set /a "len+=%%a"
						set "s=!s:~%%a!"
					)
				)
				rem Insert ,00, every second character.
				set "string="
				set /a max=!len!/2
				for /l %%i in (0,1,!max!) do (
					set /a first=%%i*2
					call set "tmpstr=%%_value:~!first!,2%%"
					if defined tmpstr (
						set string=!string!!tmpstr!,00,
					)
				)
				rem Insert new line at the end of the string.
				rem set _value=!string!00,00,00,00
				rem ... or, maybe not.
				set _value=!string!
			)
		)
		rem If value exists, write to file.
		rem First if statement won't work in Windows XP.
		rem if !_errlvl!==0 echo "%%j"=!_prefix!!_value!!_suffix!>> !_file!
		rem This one works in Windows XP and Windows 7.
		if [!_type!] NEQ [] (
			if [!_value!] NEQ [] (
				echo "%%j"=!_prefix!!_value!!_suffix!>> !_file!
				rem echo REG: "%%j"=!_prefix!!_value!!_suffix!
			)
		) else (
			rem Save default value.
			call echo "%%j"=%%myDefaultVal[%%i][!counter!]%%>> !_file!
			rem call echo DEF: "%%j"=%%myDefaultVal[%%i][!counter!]%%
		)
		set /a counter+=1
	)
	rem Add new line for readability.
	echo.>> !_file!
)

if %_method%==1 goto :createDescription
if %_method%==2 goto :exportAdditionalSettings





::================================================================================
:: Read and save other settings and tracklist.
::================================================================================

:exportAdditionalSettings

:: File to store the additional settings.
set _file="%_rel_path%\other.reg"

:: Prepare file.
echo Windows Registry Editor Version 5.00> %_file%
echo.>> %_file%

:: List of additional keys and values.
set "myAddKey[0]=HKEY_CURRENT_USER\Software\Totem\vghd"
set "myAddKey[1]=HKEY_CURRENT_USER\Software\Totem\vghd\myCollection\disabledFilters"
set "myAddKey[2]=HKEY_CURRENT_USER\Software\Totem\vghd\parameters"
set "myAddKey[3]=HKEY_CURRENT_USER\Software\Totem\vghd\store"
set "myAddKey[4]=HKEY_CURRENT_USER\Software\Totem\vghd\store\disabledFilters"
set "myAddKey[5]=HKEY_CURRENT_USER\Software\Totem\vghd\ui\fullscreen"
set "myAddKey[6]=HKEY_CURRENT_USER\Software\Totem\vghd\ui\music"
set "myAddKey[7]=HKEY_CURRENT_USER\Software\Totem\vghd\dlm_server"
set myAddValues[0]=musicSoundEnabled defaultVideoType
set myAddValues[1]=AlwaysFilter CategoryFilter CollectionFilter EthnicFilter HairFilter QualityFilter ReleaseDateFilter ResolutionFilter StateFilter StatusFilter
set myAddValues[2]=ModelIconScale ModelsSort ModelsView WindowPlayer
set myAddValues[3]=ModelIconScale ModelsSort ModelsView
set myAddValues[4]=CategoryFilter CollectionFilter EthnicFilter HairFilter QualityFilter ReleaseDateFilter WishedFilter
set myAddValues[5]=Scale
set myAddValues[6]=Scale
set myAddValues[7]=maxDeletedDemoSize maxUserDefinedPreviewsBuffer

:: Default values.
set "myDefaultVal[0][0]=dword:00000064"
set myDefaultVal[0][1]="480p"
set "myDefaultVal[1][0]=hex(7):00,00"
set "myDefaultVal[1][1]=hex(7):00,00"
set "myDefaultVal[1][2]=hex(7):00,00"
set "myDefaultVal[1][3]=hex(7):00,00"
set "myDefaultVal[1][4]=hex(7):00,00"
set "myDefaultVal[1][5]=hex(7):00,00"
set "myDefaultVal[1][6]=hex(7):00,00"
set "myDefaultVal[1][7]=hex(7):00,00"
set "myDefaultVal[1][8]=hex(7):00,00"
set "myDefaultVal[1][9]=hex(7):00,00"
set "myDefaultVal[2][0]=dword:00000032"
set "myDefaultVal[2][1]=dword:00000003"
set "myDefaultVal[2][2]=dword:00000000"
set "myDefaultVal[2][3]=dword:00000001"
set "myDefaultVal[3][0]=dword:00000032"
set "myDefaultVal[3][1]=dword:fffffffd"
set "myDefaultVal[3][2]=dword:00000002"
set "myDefaultVal[4][0]=hex(7):61,00,6e,00,61,00,6c,00,00,00,61,00,72,00,6d,00,79,00,00,00,62,00,61,00,62,00,79,00,64,00,6f,00,6c,00,6c,00,00,00,6e,00,61,00,6b,00,65,00,64,00,20,00,66,00,65,00,65,00,74,00,00,00,62,00,69,00,67,00,20,00,62,00,6f,00,6f,00,62,00,73,00,00,00,62,00,69,00,6b,00,65,00,73,00,00,00,62,00,69,00,6b,00,69,00,6e,00,69,00,00,00,62,00,6f,00,64,00,79,00,20,00,63,00,72,00,65,00,61,00,6d,00,00,00,62,00,75,00,6e,00,6e,00,79,00,00,00,68,00,61,00,69,00,72,00,79,00,00,00,63,00,61,00,67,00,65,00,00,00,63,00,61,00,72,00,73,00,00,00,63,00,6f,00,70,00,00,00,63,00,6f,00,77,00,67,00,69,00,72,00,6c,00,00,00,64,00,72,00,65,00,73,00,73,00,00,00,66,00,69,00,72,00,65,00,66,00,69,00,67,00,68,00,74,00,65,00,72,00,00,00,66,00,6c,00,69,00,67,00,68,00,74,00,20,00,61,00,74,00,74,00,65,00,6e,00,64,00,61,00,6e,00,74,00,00,00,67,00,61,00,6e,00,67,00,73,00,74,00,65,00,72,00,00,00,67,00,6c,00,61,00,73,00,73,00,00,00,68,00,69,00,67,00,68,00,20,00,68,00,65,00,65,00,6c,00,73,00,00,00,6c,00,61,00,74,00,65,00,78,00,00,00,6c,00,65,00,61,00,74,00,68,00,65,00,72,00,00,00,64,00,75,00,6f,00,00,00,6c,00,69,00,6e,00,67,00,65,00,72,00,69,00,65,00,00,00,6d,00,61,00,69,00,64,00,00,00,6e,00,61,00,76,00,79,00,00,00,6e,00,75,00,72,00,73,00,65,00,00,00,70,00,69,00,65,00,72,00,63,00,69,00,6e,00,67,00,00,00,70,00,6f,00,72,00,6e,00,20,00,73,00,74,00,61,00,72,00,00,00,70,00,72,00,69,00,73,00,6f,00,6e,00,65,00,72,00,00,00,73,00,65,00,63,00,72,00,65,00,74,00,61,00,72,00,79,00,00,00,73,00,68,00,61,00,76,00,65,00,64,00,00,00,73,00,6b,00,69,00,6e,00,6e,00,79,00,00,00,73,00,6b,00,69,00,72,00,74,00,73,00,00,00,73,00,70,00,65,00,63,00,69,00,61,00,6c,00,20,00,6f,00,63,00,63,00,61,00,73,00,69,00,6f,00,6e,00,73,00,00,00,73,00,70,00,6f,00,72,00,74,00,00,00,73,00,74,00,6f,00,63,00,6b,00,69,00,6e,00,67,00,73,00,00,00,73,00,74,00,75,00,64,00,65,00,6e,00,74,00,00,00,73,00,77,00,69,00,6e,00,67,00,00,00,74,00,61,00,74,00,74,00,6f,00,6f,00,73,00,00,00,74,00,69,00,6e,00,79,00,20,00,74,00,69,00,74,00,73,00,00,00,74,00,72,00,69,00,6d,00,6d,00,65,00,64,00,00,00,75,00,73,00,20,00,73,00,74,00,61,00,72,00,73,00,00,00,77,00,65,00,74,00,20,00,74,00,2d,00,73,00,68,00,69,00,72,00,74,00,00,00,00,00"
set "myDefaultVal[4][1]=hex(7):00,00"
set "myDefaultVal[4][2]=hex(7):00,00"
set "myDefaultVal[4][3]=hex(7):00,00"
set "myDefaultVal[4][4]=hex(7):00,00"
set "myDefaultVal[4][5]=hex(7):00,00"
set "myDefaultVal[4][6]=hex(7):4d,00,79,00,20,00,77,00,69,00,73,00,68,00,6c,00,69,00,73,00,74,00,00,00,00,00"
set "myDefaultVal[5][0]=dword:00000064"
set "myDefaultVal[6][0]=dword:00000064"
set myDefaultVal[7][0]="8589934592"
set myDefaultVal[7][1]="8589934592"

:: Count the number of additional keys to process.
set /a "keys_length=-1"
for /f %%a in ('set myAddKey[') do set /a "keys_length+=1"

:: Loop - the same loop as before. I know, this is stupid to copy the same code
:: instead of putting it to some function, but this was easier. Besides, who cares?
for /l %%i in (0,1,%keys_length%) do (
	echo [!myAddKey[%%i]!]>> !_file!
	set /a counter=0
	rem Save values
	for %%j in (!myAddValues[%%i]!) do (
		rem Read value and type from the registry.
		rem It should be one of these three types of value: REG_DWORD, REG_SZ, REG_MULTI_SZ.
		set "_type="
		set "_value="
		set "_errlvl="
		set "_prefix="
		set "_suffix="
		call :readRegValue "!myAddKey[%%i]!" %%j _type _value _errlvl
		rem Check type.
		if /i !_type!==REG_DWORD (
			set "_prefix=dword:"
			set "_suffix="
			rem Remove the '0x' at the begginig of each value of this type.
			call set "_value=%%_value:0x=%%"
		) else if /i !_type!==REG_SZ (
			set "_prefix=""
			set "_suffix=""
			rem Replace single backslash (\) with double backslash (\\).
			call set "_value=%%_value:\=\\%%"
		) else if /i !_type!==REG_MULTI_SZ (
			set "_prefix=hex(7):"
			set "_suffix="
			rem Check if value isn't empty.
			IF [!_value!] EQU [] (
				set _value=00,00
			) else (
				rem Convert text to hex. Store the string in str.tmp file.
				set /p "=!_value!" < nul > str.tmp
				rem Create null.tmp file with the same number of Ascii zero characters.
				for %%a in (str.tmp) do fsutil file createnew null.tmp %%~za > nul
				rem Compare both files with FC /B and get the differences.
				set "hex="
				for /f "skip=1 tokens=2" %%a in ('fc /b str.tmp null.tmp') do set "hex=!hex!%%a"
				rem .tmp files are no longer used.
				del str.tmp null.tmp
				rem Replace Ascii '\0' with nul.
				call set "_value=%%hex:5C30=00%%"
				rem Get length of the string.
				set "len=0"
				set "s=!_value!"
				for %%a in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
					if "!s:~%%a,1!" NEQ "" (
						set /a "len+=%%a"
						set "s=!s:~%%a!"
					)
				)
				rem Insert ,00, every second character.
				set "string="
				set /a max=!len!/2
				for /l %%i in (0,1,!max!) do (
					set /a first=%%i*2
					call set "tmpstr=%%_value:~!first!,2%%"
					if defined tmpstr (
						set string=!string!!tmpstr!,00,
					)
				)
				rem Insert new line at the end of the string.
				rem set _value=!string!00,00,00,00
				rem ... or, maybe not.
				set _value=!string!
			)
		)
		rem If value exists, write to file.
		rem First if statement won't work in Windows XP.
		rem if !_errlvl!==0 echo "%%j"=!_prefix!!_value!!_suffix!>> !_file!
		rem This one works in Windows XP and Windows 7.
		if [!_type!] NEQ [] (
			if [!_value!] NEQ [] (
				echo "%%j"=!_prefix!!_value!!_suffix!>> !_file!
				rem echo REG: "%%j"=!_prefix!!_value!!_suffix!
			)
		) else (
			rem Save default value.
			call echo "%%j"=%%myDefaultVal[%%i][!counter!]%%>> !_file!
			rem call echo DEF: "%%j"=%%myDefaultVal[%%i][!counter!]%%
		)
		set /a counter+=1
	)
	rem Add new line for readability.
	echo.>> !_file!
)

:: Scenes should be exported directly to .reg file.
set "scenes=HKEY_CURRENT_USER\Software\Totem\vghd\Scenes"
set _file="%_rel_path%\scenes.reg"
reg export %scenes% %_file% >nul 2>nul

:: Copy tracklist (musiclist.mpl)
set reg_key=HKEY_CURRENT_USER\Software\Totem\vghd\System
set reg_var=DataPath
set "data_path="
for /f "tokens=2*" %%i in ('reg query %reg_key% /v %reg_var% 2^>nul ^| findstr /i %reg_var%') do set "data_path=%%j"
set "_source=%data_path%\musics\musiclist.mpl"
call set "_source=%%_source:\\=\%%"
set "_destination=%_rel_path%\musiclist.mpl"
copy /y "%_source%" "%_destination%" >nul 2>nul





::================================================================================
:: Create description file.
::================================================================================

:createDescription

:: Create info.txt file with creation date and short description provided by the user.
set _file="%_rel_path%\info.txt"
for /f "usebackq tokens=*" %%i in (`date /t`) do set _date=%%i
for /f "usebackq tokens=*" %%i in (`time /t`) do set _time=%%i
echo date="%_date%%_time%"> %_file%

:: Let the user provide some description.
call :ShowTitle export

echo  STEP 4/%steps%: ADD DESCRIPTION
echo ----------------------------
echo.
echo You can provide a short description for this set of settings.
echo It will be saved in .txt file in the same folder along with exported settings.
echo.
echo Description can be max. 1000 characters long. You can use letters, digits,
echo special characters:   (space); _ (underscore); - (dash); . (dot);
echo Try to avoid other special characters because they may break the script.
echo For complete list of special characters, refer to readme file.
echo.
echo If you don't want to provide description, just press [Enter].
echo.
set /p "_desc=Description: "
echo description="%_desc%">> %_file%





::================================================================================
:: Set current settings as default.
::================================================================================

:setAsDefaultExport
call :ShowTitle export

echo  STEP 5/%steps%: SET AS DEFAULT
echo ---------------------------
echo.
echo Would you like to set current settings as default?
echo.
echo New shortcut to the iStripper application will be created and placed on your
echo desktop. Use this shortcut to run iStripper with your new default settings.
echo.
echo -------------------------------
echo  [Y] Yes, I would like to.
echo  [N] No, just leave me alone^^!
echo -------------------------------
echo.

:: Action
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :setAsDefaultExport
if /i %_choice% == n (
	goto :doneExport
) else (
	if /i !_choice! == y (
		goto :setAsDefaultExport_action
	) else (
		goto :setAsDefaultExport
	)
)

:setAsDefaultExport_action
:: Save the name of current settings to .txt file.
if %_method%==1 (
	rem Use only basic settings.
	echo "!_setting_name!#bsc"> !_default_txt!
) else (
	rem Use all settings.
	echo "!_setting_name!#all"> !_default_txt!
)

:: Create shotcut.
call :createShortcut





::================================================================================
:: Export done.
::================================================================================

:doneExport
call :showTitle export

echo Done. Settings have been saved in:
echo %_root_path%%_settings_path%\%_setting_name%
echo.
echo What now?
echo.
echo ------------------------
echo  [B] Back to main menu
echo  [Q] Quit
echo ------------------------
echo.

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :doneExport
if /i %_choice% == q exit
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :doneExport
)










::################################################################################
:: Import settings
::################################################################################
:: 1 - Select folder with settings (other opt: Browse settings, Help, Back, Quit).
:: 2 - Select range: Basic, Everything (other opt: Description, Help, Back, Quit).
:: 3 - Accept/Confirm (other opt: Back, Quit).
:: 4 - Set as default: Yes, No.

:import
call :showTitle import
set "steps=4"

echo  STEP 1/%steps%: SELECT SETTINGS
echo ----------------------------
echo.
echo So you want to import settings, huh? Select the folder with settings to import.
echo.
echo -----------------------------
echo  [1] Import settings
echo  [O] Browse settings folder
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo -----------------------------
echo.

:: Show warning message.
if defined message (
	if !message! EQU 1 (
		echo ERROR: You can't choose the root folder. Try again.
		echo.
		set "message="
	)
)

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :import
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	for /f "delims=" %%i in ('cscript /nologo /e:jscript "%~f0" "!_root_path!!_settings_path!"') do (
		set "selected_path=%%i"
		if "!selected_path!" EQU "!_root_path!!_settings_path!" (
			set "message=1"
			goto :import
		) else (
			set "_setting_name=%%~ni"
			goto :importSelectRange
		)
	)
)
if /i %_choice% == o (
	set flag=1
	explorer "!_settings_path!"
	goto :import
)
if /i %_choice% == h (
	set flag=1
	goto :helpImport
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :import
)





::================================================================================
:: Choose if you want to import all settings or basic settings.
::================================================================================

:importSelectRange
:: Check if selected path is empty or root. If it is, go back one step.
if "%selected_path%"=="" goto :import
if "%selected_path%"=="%_root_path%%_settings_path%" goto :import

call :showTitle import

echo  STEP 2/%steps%: SELECT RANGE
echo -------------------------

:: Check if these are basic settings or all settings.
set "basic=1"
if exist "%_settings_path%\%_setting_name%\settings.reg" (
	if exist "!_settings_path!\!_setting_name!\other.reg" set "basic=0"
	if exist "!_settings_path!\!_setting_name!\scenes.reg" set "basic=0"
	if exist "!_settings_path!\!_setting_name!\musiclist.mpl" set "basic=0"
)

echo.
echo You are about to import the following settings: "%_setting_name%"
echo.
if %basic%==1 echo These are the basic settings (from the "Settings" tab), without filter
if %basic%==1 echo settings, sort settings, scene settings, music files settings etc.
if %basic%==1 echo Option "Import everything" is not available for this kind of set.
if %basic%==0 echo This set of settings contains all settings, including those from
if %basic%==0 echo the "Settings" tab, filters, views, sort, scene and tracks settings.
if %basic%==0 echo You can still choose whether you want to import only the basic
if %basic%==0 echo settings or all of the settings available in this set.
echo.
echo ----------------------------
echo  [1] Import basic settings
if %basic%==0 echo  [2] Import everything
echo  [D] Show description
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ----------------------------
echo.

:: Show description (or warning message).
if defined message (
	if !message! EQU 1 (
		echo Creation date: !date!
		echo Description: !description!
		echo.
		set "message="
	)
	if !message! EQU 2 (
		echo ERROR: Can't load description. The "info.txt" file is missing.
		echo.
		set "message="
	)
	if !message! EQU 3 (
		echo ERROR: There's nothing to import. The "settings.reg" file is missing.
		echo Try to go back and choose another set of settings.
		echo.
		set "message="
	)
)

:: Action.
set "_method="
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :importSelectRange
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	rem Check if there is a file to read.
	if not exist "!_settings_path!\!_setting_name!\settings.reg" (
		set "message=3"
		goto :importSelectRange
	) else (
		set "_method=1"
		goto :importAccept
	)
)
if /i %_choice% == 2 (
	set flag=1
	if %basic%==1 (
		goto :importSelectRange
	) else (
		set "_method=2"
		goto :importCheckFiles
	)
)
if /i %_choice% == d (
	set flag=1
	set "message="
	rem Read desription from the .txt file.
	set "desc_path=!_settings_path!\!_setting_name!\info.txt"
	if exist "!desc_path!" (
		set "desc[1]="
		set "desc[2]="
		rem Get values of each variable.
		set "counter=0"
		for /f "usebackq tokens=2,* delims==" %%i in ("!desc_path!") do (
			set /a counter+=1
			set desc[!counter!]=%%i
		)
		set "date=!desc[1]:~1,-1!"
		set "description=!desc[2]:~1,-1!"
		rem Display description.
		set "message=1"
	) else (
		set "message=2"
	)
	goto :importSelectRange
)
if /i %_choice% == h (
	set flag=1
	goto :helpImportRange
)
if /i %_choice% == b (
	set flag=1
	goto :import
)
if %flag% EQU 0 (
	goto :importSelectRange
)





::================================================================================
:: User decided to import everything, but some files are missing.
::================================================================================

:importCheckFiles
:: If at lest one file is missing, this var should be equal to 1.
set "file_missing=0"

:: Check if all files are available.
if not exist "%_settings_path%\%_setting_name%\settings.reg" set "file_missing=1"
if not exist "%_settings_path%\%_setting_name%\other.reg" set "file_missing=1"
if not exist "%_settings_path%\%_setting_name%\scenes.reg" set "file_missing=1"
if not exist "%_settings_path%\%_setting_name%\musiclist.mpl" set "file_missing=1"

:: If any file is missing, the warning message should be displayed.
if %file_missing%==1 (
	goto :importAnyway
) else (
	goto :importAccept
)

:importAnyway
call :showTitle import

echo  STEP 2/%steps%: SELECT RANGE
echo -------------------------
echo.
echo WARNING: It looks like at least one of the files is missing.
echo Do you want the script to try to import these settings anyway?
echo.
echo ----------
echo  [Y] Yes
echo  [N] No
echo ----------
echo.

:: Action
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :importAnyway
if /i %_choice% == n (
	goto :importSelectRange
) else (
	if /i !_choice! == y (
		goto :importAccept
	) else (
		goto :importAnyway
	)
)





::================================================================================
:: Accept the choice and import now.
::================================================================================

:importAccept
call :showTitle import

echo  STEP 3/%steps%: CONFIRM
echo --------------------
echo.
echo Selected settings: "%_setting_name%"
if %_method% EQU 1 echo Program will import only basic settings (from the "Settings" tab).
if %_method% EQU 2 echo Program will import all settings.
echo.
echo Choose "Import now" to import selected settings.
echo.
echo -----------------
echo  [1] Import now
echo  [B] Back
echo  [Q] Quit
echo -----------------
echo.

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :importAccept
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	goto :importBasicSettings
)
if /i %_choice% == b (
	set flag=1
	goto :importSelectRange
)
if %flag% EQU 0 (
	goto :importAccept
)





::================================================================================
:: Import basic settings to the registry ("Settings" tab).
::================================================================================

:importBasicSettings

:: Relative path to the current set of settings.
set "_rel_path=%_settings_path%\%_setting_name%"
reg import "%_rel_path%\settings.reg" >nul 2>nul

if %_method%==1 goto :setAsDefaultImport
if %_method%==2 goto :importAdditionalSettings





::================================================================================
:: Import other settings and tracklist.
::================================================================================

:importAdditionalSettings

:: Import filters and view options.
if exist "%_rel_path%\other.reg" (
	reg import "!_rel_path!\other.reg" >nul 2>nul
)

:: Import scene options.
if exist "%_rel_path%\scenes.reg" (
	reg import "!_rel_path!\scenes.reg" >nul 2>nul
)

:: Import tracklist (musiclist.mpl)
if exist "%_rel_path%\musiclist.mpl" (
	set reg_key=HKEY_CURRENT_USER\Software\Totem\vghd\System
	set reg_var=DataPath
	set "data_path="
	for /f "tokens=2*" %%i in ('reg query !reg_key! /v !reg_var! 2^>nul ^| findstr /i !reg_var!') do set "data_path=%%j"
	set "_source=!_rel_path!\musiclist.mpl"
	set "_destination=!data_path!\musics\musiclist.mpl"
	call set "_destination=%%_destination:\\=\%%"
	copy /y "!_source!" "!_destination!" >nul 2>nul
)





::================================================================================
:: Set current settings as default.
::================================================================================

:setAsDefaultImport
call :ShowTitle import

echo  STEP 4/%steps%: SET AS DEFAULT
echo ---------------------------
echo.
echo Would you like to set current settings as default?
echo.
echo New shortcut to the iStripper application will be created and placed on your
echo desktop. Use this shortcut to run iStripper with your new default settings.
echo.
echo --------------------------
echo  [Y] Yes, with pleasure.
echo  [N] No, not this time.
echo --------------------------
echo.

:: Action
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :setAsDefaultImport
if /i %_choice% == n (
	goto :doneImport
) else (
	if /i !_choice! == y (
		goto :setAsDefaultImport_action
	) else (
		goto :setAsDefaultImport
	)
)

:setAsDefaultImport_action
:: Save the name of current settings to .txt file.
if %_method%==1 (
	rem Use only basic settings.
	echo "!_setting_name!#bsc"> !_default_txt!
) else (
	rem Use all settings.
	echo "!_setting_name!#all"> !_default_txt!
)

:: Create shotcut.
set lnk_script=create_shortcut.vbs
set lnk_filename="%USERPROFILE%\Desktop\iStripper (default).lnk"
set lnk_target="%_root_path%run_default.vbs"
set lnk_args=""
set lnk_workdir="%_root_path%"
set lnk_icon="%_root_path%is.ico"
call :createShortcut





::================================================================================
:: Import done.
::================================================================================

:doneImport
call :showTitle import

echo Done. Settings "%_setting_name%" have been imported.
echo If iStripper is running, restart it to see the changes.
echo.
echo What now?
echo.
echo ------------------------
echo  [B] Back to main menu
echo  [Q] Quit
echo ------------------------
echo.

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :doneImport
if /i %_choice% == q exit
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :doneImport
)










::################################################################################
:: Save your settings as default.
::################################################################################
:: 1 - Select folder with settings (other opt: Browse settings, Help, Back, Quit).
:: 2 - Select range: Basic, Everything (other opt: Description, Help, Back, Quit).
:: 3 - Accept/Confirm (other opt: Back, Quit).

:default
call :showTitle
set "steps=3"

echo  STEP 1/%steps%: SELECT SETTINGS
echo ----------------------------
echo.
echo So you want to set default settings, huh? Which one would you like to choose?
echo.
echo -----------------------------
echo  [1] Choose settings
echo  [O] Browse settings folder
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo -----------------------------
echo.

:: Show warning message.
if defined message (
	if !message! EQU 1 (
		echo ERROR: You can't choose the root folder. Try again.
		echo.
		set "message="
	)
)

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :default
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	for /f "delims=" %%i in ('cscript /nologo /e:jscript "%~f0" "!_root_path!!_settings_path!"') do (
		set "selected_path=%%i"
		if "!selected_path!" EQU "!_root_path!!_settings_path!" (
			set "message=1"
			goto :default
		) else (
			set "_setting_name=%%~ni"
			goto :defaultSelectRange
		)
	)
)
if /i %_choice% == o (
	set flag=1
	explorer "!_settings_path!"
	goto :default
)
if /i %_choice% == h (
	set flag=1
	goto :helpDefault
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :default
)





::================================================================================
:: Provide the name of the set of the settings to use as default.
::================================================================================

:defaultSelectRange
call :showTitle

echo  STEP 2/%steps%: SELECT RANGE
echo -------------------------

:: Check if these are basic settings or all settings.
set "basic=1"
if exist "%_settings_path%\%_setting_name%\settings.reg" (
	if exist "!_settings_path!\!_setting_name!\other.reg" set "basic=0"
	if exist "!_settings_path!\!_setting_name!\scenes.reg" set "basic=0"
	if exist "!_settings_path!\!_setting_name!\musiclist.mpl" set "basic=0"
)

echo.
echo You are about to include the following settings: "%_setting_name%"
echo.
if %basic%==1 echo These are the basic settings (from the "Settings" tab), without filter
if %basic%==1 echo settings, sort settings, scene settings, music files settings etc.
if %basic%==1 echo Option "Include everything" is not available for this kind of set.
if %basic%==0 echo This set of settings contains all settings, including those from
if %basic%==0 echo the "Settings" tab, filters, views, sort, scene and tracks settings.
if %basic%==0 echo You can still choose whether you want to include only the basic
if %basic%==0 echo settings or all of the settings available in this set.
echo.
echo -----------------------------
echo  [1] Include basic settings
if %basic%==0 echo  [2] Include everything
echo  [D] Show description
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo -----------------------------
echo.

:: Show description (or warning message).
if defined message (
	if !message! EQU 1 (
		echo Creation date: !date!
		echo Description: !description!
		echo.
		set "message="
	)
	if !message! EQU 2 (
		echo ERROR: Can't load description. The "info.txt" file is missing.
		echo.
		set "message="
	)
	if !message! EQU 3 (
		echo ERROR: There's nothing to include. The "settings.reg" file is missing.
		echo Try to go back and choose another set of settings.
		echo.
		set "message="
	)
)

:: Action.
set "_method="
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :defaultSelectRange
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	rem Check if there is a file to read.
	if not exist "!_settings_path!\!_setting_name!\settings.reg" (
		set "message=3"
		goto :defaultSelectRange
	) else (
		set "_method=1"
		goto :defaultAccept
	)
)
if /i %_choice% == 2 (
	set flag=1
	if %basic%==1 (
		goto :defaultSelectRange
	) else (
		set "_method=2"
		goto :defaultCheckFiles
	)
)
if /i %_choice% == d (
	set flag=1
	set "message="
	rem Read desription from the .txt file.
	set "desc_path=!_settings_path!\!_setting_name!\info.txt"
	if exist "!desc_path!" (
		set "desc[1]="
		set "desc[2]="
		rem Get values of each variable.
		set "counter=0"
		for /f "usebackq tokens=2,* delims==" %%i in ("!desc_path!") do (
			set /a counter+=1
			set desc[!counter!]=%%i
		)
		set "date=!desc[1]:~1,-1!"
		set "description=!desc[2]:~1,-1!"
		rem Display description.
		set "message=1"
	) else (
		set "message=2"
	)
	goto :defaultSelectRange
)
if /i %_choice% == h (
	set flag=1
	goto :helpDefaultRange
)
if /i %_choice% == b (
	set flag=1
	goto :default
)
if %flag% EQU 0 (
	goto :defaultSelectRange
)





::================================================================================
:: User decided to include everything, but some files are missing.
::================================================================================

:defaultCheckFiles
:: If at lest one file is missing, this var should be equal to 1.
set "file_missing=0"

:: Check if all files are available.
if not exist "%_settings_path%\%_setting_name%\settings.reg" set "file_missing=1"
if not exist "%_settings_path%\%_setting_name%\other.reg" set "file_missing=1"
if not exist "%_settings_path%\%_setting_name%\scenes.reg" set "file_missing=1"
if not exist "%_settings_path%\%_setting_name%\musiclist.mpl" set "file_missing=1"

:: If any file is missing, the warning message should be displayed.
if %file_missing%==1 (
	goto :defaultAnyway
) else (
	goto :defaultAccept
)

:defaultAnyway
call :showTitle

echo  STEP 2/%steps%: SELECT RANGE
echo -------------------------
echo.
echo WARNING: It looks like at least one of the files is missing.
echo Do you want the script to try to include these settings anyway?
echo.
echo ----------
echo  [Y] Yes
echo  [N] No
echo ----------
echo.

:: Action
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :defaultAnyway
if /i %_choice% == n (
	goto :defaultSelectRange
) else (
	if /i !_choice! == y (
		goto :defaultAccept
	) else (
		goto :defaultAnyway
	)
)





::================================================================================
:: Accept the choice and set the defaults now.
::================================================================================

:defaultAccept
call :showTitle

echo  STEP 3/%steps%: CONFIRM
echo --------------------
echo.
echo Selected settings: "%_setting_name%"
if %_method% EQU 1 echo Program will use only basic settings (from the "Settings" tab) as default.
if %_method% EQU 2 echo Program will use all settings as default.
echo.
echo New shortcut to the iStripper application will be created and placed on your
echo desktop. Use this shortcut to run iStripper with your new default settings.
echo.
echo Choose "Set now" to set selected settings as default.
echo.
echo --------------
echo  [1] Set now
echo  [B] Back
echo  [Q] Quit
echo --------------
echo.

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :defaultAccept
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	rem Save to default.txt.
	if !_method!==1 (
		rem Use only basic settings.
		echo "!_setting_name!#bsc"> !_default_txt!
	) else (
		rem Use all settings.
		echo "!_setting_name!#all"> !_default_txt!
	)
	rem Create the shortcut.
	call :createShortcut
	rem Done.
	goto :doneDefault
)
if /i %_choice% == b (
	set flag=1
	goto :defaultSelectRange
)
if %flag% EQU 0 (
	goto :defaultAccept
)





::================================================================================
:: Set as default - done.
::================================================================================

:doneDefault
call :showTitle

echo Done. Selected settings have been set as default.
echo.
echo What now?
echo.
echo ------------------------
echo  [B] Back to main menu
echo  [Q] Quit
echo ------------------------
echo.

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :doneDefault
if /i %_choice% == q exit
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :doneDefault
)










::################################################################################
:: Reset iStripper settings.
::################################################################################

:reset
call :showTitle
set "steps=1"

echo  STEP 1/%steps%: RESET SETTINGS
echo ---------------------------
echo.
echo Settings Manager can restore the default (factory) settings of iStripper.
echo The same settings will apply as after the fresh installation of iStripper.
echo Directory paths will not be changed.
echo.
echo Do you want to restore the factory settings now?
echo.
echo ----------
echo  [Y] Yes
echo  [N] No
echo ----------
echo.

:: Action.
set "_choice="
set /p "_choice=Your choice: "
if [%_choice%]==[] goto :reset
if /i %_choice% == n (
	goto :start
) else (
	if /i !_choice! == y (
		reg import "factory.reg" >nul 2>nul
		goto :doneReset
	) else (
		goto :reset
	)
)





::================================================================================
:: Reset - done.
::================================================================================

:doneReset
call :showTitle

echo Done. iStripper settings have been restored.
echo If iStripper is running, restart it to see the changes.
echo.
echo What now?
echo.
echo ------------------------
echo  [B] Back to main menu
echo  [Q] Quit
echo ------------------------
echo.

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :doneReset
if /i %_choice% == q exit
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :doneReset
)










::################################################################################
:: Usefull functions.
::################################################################################

:: Display title.
:showTitle <module>
set "title_1=                    Settings Manager for iStripper (v1.2)"
set "title_2=               Settings Manager for iStripper (v1.2) - EXPORT"
set "title_3=               Settings Manager for iStripper (v1.2) - IMPORT"
set "_title_line_1================================================================================
if [%1]==[] (
	set "_title_line_2=!title_1!"
) else (
	if "%1"=="export" set "_title_line_2=!title_2!"
	if "%1"=="import" set "_title_line_2=!title_3!"
)
echo Param: %1
set "_title_line_3================================================================================
cls
set i_max=3
for /l %%i in (1,1,%i_max%) do (
	echo !_title_line_%%i!
	if %%i LSS !i_max! echo.
)
echo.
exit /b

:: Trim spaces in provided name.
:: Source: https://stackoverflow.com/questions/3001999/how-to-remove-trailing-and-leading-whitespace-for-user-provided-input-in-a-batch
:trim <resultString> <inputString>
setLocal EnableDelayedExpansion
set params=%*
for /f "tokens=1*" %%a in ("%params%") do endLocal & set %1=%%b
exit /b

:: Read values from registry key.
:readRegValue <regKey> <regVarName> <resultType> <resultValue> <errorLevel>
for /f "tokens=2*" %%a in ('reg query %1 /v "%2" 2^>nul ^| find /i "%2"') do (
	set "%3=%%a"
	set "%4=%%b"
	set "%5=%ERRORLEVEL%"
)
exit /b

:: Get the length of the string.
:strlen <resultLength> <inputString>
setLocal EnableDelayedExpansion
set "s=!%~2!#"
set "len=0"
for %%a in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
	if "!s:~%%a,1!" NEQ "" (
		set /a "len+=%%a"
		set "s=!s:~%%a!"
	)
)
endLocal & set "%~1=!len!"
exit /b

:: Create shortcut on user's desktop.
:createShortcut
set lnk_script=create_shortcut.vbs
set lnk_path="%USERPROFILE%\Desktop"
set lnk_filename="iStripper (default).lnk"
set lnk_target="%_root_path%run_default.vbs"
set lnk_icon="%_root_path%is.ico"
set lnk_desc="Run iStripper with default settings"
set lnk_args=""
set lnk_workdir="%_root_path%"
rem Usage: create_shortcut.vbs shortcut_path shortcut_name target icon_path shortcut_description arguments working_dir
cscript /nologo %lnk_script% %lnk_path% %lnk_filename% %lnk_target% %lnk_icon% %lnk_desc% %lnk_args% %lnk_workdir%
exit /b










goto :EOF

:: JScript */

var shl = new ActiveXObject("Shell.Application");
var root = WScript.Arguments(0);
var folder = shl.BrowseForFolder(0, "Select folder with your settings.", 0, root);
WSH.Echo(folder ? folder.self.path : '');
