@echo off
title Settings manager
setlocal EnableDelayedExpansion
cls

:getDefaultSettings
:: Get the name of default settings and other variables from .txt file.
set "_default="
set "_method="
if exist default.txt (
	set /p default=<default.txt
	call set "default=%%default:"=%%"
	call set "_default=%%default:~0,-4%%"
	call set "_method=%%default:~-4%%"
	goto :resetSettingsToDefault
) else (
	echo Can't find default settings. Exit in 5 seconds...
	ping -n 6 127.0.0.1>nul
	exit
)

:resetSettingsToDefault
:: Set default settings
set "settings=settings\%_default%\settings.reg"
if exist %settings% reg import "%settings%" >nul 2>nul
if %_method% EQU #all (
	rem Filters, views and sort options.
	set "settings=settings\!_default!\other.reg"
	if exist !settings! reg import "!settings!" >nul 2>nul
	rem Scenes.
	set "settings=settings\!_default!\scenes.reg"
	if exist !settings! reg import "!settings!" >nul 2>nul
	rem Tracks.
	set "_source=settings\!_default!\musiclist.mpl"
	set reg_key=HKEY_CURRENT_USER\Software\Totem\vghd\System
	set reg_var=DataPath
	set "data_path="
	for /f "tokens=2*" %%i in ('reg query !reg_key! /v !reg_var! 2^>nul ^| findstr /i !reg_var!') do set "data_path=%%j"
	set "_destination=!data_path!\musics\musiclist.mpl"
	call set "_destination=%%_destination:\\=\%%"
	copy /y !_source! !_destination! >nul 2>nul
)

:runApp
:: Get the path to vghd.exe
set reg_key=HKEY_CURRENT_USER\Software\Totem\vghd\System
set reg_var=MainPath
set "main_path="
for /f "tokens=2*" %%i in ('reg query %reg_key% /v %reg_var% 2^>nul ^| findstr /i %reg_var%') do set "main_path=%%j"
set "target=%main_path%\vghd.exe"
call set "target=%%target:\\=\%%"
:: Run application.
start "" "%target%"

:exit
exit
