@if (@a==@b) @end /*

@echo off
rem Color 0F
Color 1F
setlocal EnableDelayedExpansion

cls





::================================================================================
:: Install manager.
::================================================================================
:: 1) Select destination folder (Help, Quit)
:: 2) Create shortcut? (Help)

:start
call :showTitle
set "selected_path="

echo You are about to install Settings Manager for iStripper.
echo Select the folder where Settings Manager will be installed.
echo Press corresponding key on your keyboard and accept by pressing [Enter].
echo.
echo ---------------------------------
echo  [1] Select installation folder
echo  [H] Help
echo  [Q] Quit
echo ---------------------------------
echo.

:: Action.
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :start
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set flag=1
	for /f "delims=" %%i in ('cscript /nologo /e:jscript "%~f0"') do set "selected_path=%%i\Settings Manager for iS"
	goto :shortcut
)
if /i %_choice% == h (
	set flag=1
	goto :help
)
if %flag% EQU 0 (
	goto :start
)





::================================================================================
:: Create Shortcut?
::================================================================================

:shortcut
call :showTitle
set "shortcut="

echo Do you want to create a shortcut to Settings Manager on your desktop?
echo.
echo -----------
echo  [Y] Yes
echo  [N] No
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo -----------
echo.

:: Action
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :shortcut
if /i %_choice% == q exit
if /i %_choice% == y (
	set "flag=1"
	set "shortcut=1"
	goto :confirm
)
if /i %_choice% == n (
	set "flag=1"
	set "shortcut=0"
	goto :confirm
)
if /i %_choice% == h (
	set flag=1
	goto :helpShortcut
)
if /i %_choice% == b (
	set flag=1
	goto :start
)
if %flag% EQU 0 (
	goto :shortcut
)





::================================================================================
:: Confirm.
::================================================================================

:confirm
call :showTitle

echo You choose following options:
echo.
echo Installation path: %selected_path%
if %shortcut%==0 echo Shortcut: No
if %shortcut%==1 echo Shortcut: Yes
echo.
echo Choose "Install now" to install Settings Manager for iStripper.
echo.
echo ------------------
echo  [1] Install now
echo  [H] Help
echo  [B] Back
echo  [Q] Quit
echo ------------------
echo.

:: Action
set "flag=0"
set "_choice="
set /p "_choice=Your choice: "

if [%_choice%]==[] goto :confirm
if /i %_choice% == q exit
if /i %_choice% == 1 (
	set "flag=1"
	goto :install
)
if /i %_choice% == h (
	set flag=1
	goto :helpConfirm
)
if /i %_choice% == b (
	set flag=1
	goto :shortcut
)
if %flag% EQU 0 (
	goto :confirm
)





::================================================================================
:: Install.
::================================================================================

:install
call :showTitle

echo Installation in progress. Please wait...

:: Copy files
if not exist "%selected_path%" md "%selected_path%"
copy /y "data\create_shortcut.vbs" "%selected_path%\create_shortcut.vbs" >nul 2>nul
copy /y "data\is.ico" "%selected_path%\is.ico" >nul 2>nul
copy /y "data\manager.bat" "%selected_path%\manager.bat" >nul 2>nul
copy /y "data\manager.ico" "%selected_path%\manager.ico" >nul 2>nul
copy /y "data\run_default.bat" "%selected_path%\run_default.bat" >nul 2>nul
copy /y "data\run_default.vbs" "%selected_path%\run_default.vbs" >nul 2>nul
copy /y "data\factory.reg" "%selected_path%\factory.reg" >nul 2>nul

:: Create shortcut
if %shortcut%==1 call :createShortcut





::================================================================================
:: Done.
::================================================================================

:done
call :showTitle

echo Installation complete.
echo.
echo Press any key to exit.

pause >nul
exit










::################################################################################
:: Help.
::################################################################################

:help
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo This installer will install Settings Manager for iStripper on your computer.
echo Settings Manager can help you export/import all iStripper settings.
echo All options from the "Settings" tab, filter settings from "My Collection"
echo and "Girls Store" tabs, views, the settings of skins, scenes and music
echo files can be saved and you will be able to restore them in the future.
echo.
echo Press 1 to select installation folder for Settings Manager.
echo Press H to display tips (this text).
echo Press Q to exit the program.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :start

:helpShortcut
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo This installer can create a shortcut on your desktop so that you get
echo easy and quick access to the Settings Manager for iStripper.
echo.
echo Press Y if you want to create shortcut.
echo Press N if you don't want to create shortcut.
echo Press H to display tips (this text).
echo Press B to go back to previous menu.
echo Press Q to exit the program.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :shortcut

:helpConfirm
echo.
echo.
echo -------------------------------------------------------------------------------
echo.
echo      Quick help
echo.
echo -------------------------------------------------------------------------------
echo.
echo The installer is ready to install the software. If you want to make any changes
echo or if you want to abort the installation, this is your last chance to do this.
echo.
echo Press 1 to install Settings Manager.
echo Press H to display tips (this text).
echo Press B to go back to previous menu.
echo Press Q to exit the program.
echo.
echo -------------------------------------------------------------------------------
echo.
echo Press any key to continue.
echo.
echo.
pause >nul
goto :confirm










::################################################################################
:: Usefull functions.
::################################################################################

:: Display title.
:showTitle
set "_title_line_1================================================================================
set "_title_line_2=                        Settings Manager v1.2 Installer"
set "_title_line_3================================================================================
cls
set i_max=3
for /l %%i in (1,1,%i_max%) do (
	echo !_title_line_%%i!
	if %%i LSS !i_max! echo.
)
echo.
exit /b

:: Create shortcut on user's desktop.
:createShortcut
set lnk_script=data\create_shortcut.vbs
set lnk_path="%USERPROFILE%\Desktop"
set lnk_filename="Settings Manager.lnk"
set lnk_target="%selected_path%\manager.bat"
set lnk_icon="%selected_path%\manager.ico"
set lnk_desc="Settings Manager for iStripper"
set lnk_args=""
set lnk_workdir="%selected_path%"
rem Usage: create_shortcut.vbs shortcut_path shortcut_name target icon_path shortcut_description arguments working_dir
cscript /nologo %lnk_script% %lnk_path% %lnk_filename% %lnk_target% %lnk_icon% %lnk_desc% %lnk_args% %lnk_workdir%
exit /b










goto :EOF

:: JScript */

var shl = new ActiveXObject("Shell.Application");
var folder = shl.BrowseForFolder(0, "Select installation folder.", 0);
WSH.Echo(folder ? folder.self.path : '');
